#include "mbed.h"

DigitalOut col0(P0_4, 0);
DigitalOut myled(p13);

DigitalOut nSleep(p28, 0);	// P28 = Motortreiber enable
PwmOut in1(p29); 			// P29 = Motortreiber Eingang 1
DigitalOut in2(p30, 1); 	// P30 = Motortreiber Eingang 2

AnalogIn mic(p3);  			// P3 = MIC

DigitalIn tasteA(p17);
DigitalIn tasteB(p16);

DigitalOut pin1(p1, 0);		// Port als Widerstand benutzen

int main() {
	uint16_t len = 6000;		// Anzahl Samples, Speicher reicht ohne Waveform-Ausgabe fuer max. 7500
	uint16_t interval = 250;    // Abtastintervall in us => Abtastrate in Hz = 1/(interval*1.000.000)
							    // (=> Aufnahmedauer in s = len*interval)
	uint8_t buffer[len];		// Aufnahmepuffer
	uint16_t n = 0;
	in1.period_us(20);			// Periodendauer der PWM
	while(1) {
		if (tasteA.read() == 0) {	// Aufnahme
			myled = 1;
			for (n = 0; n < len; n++) {
				buffer[n] = int(mic.read() * 255);
				wait_us(interval-101);  // gemessene Laufzeit der vorigen Zeile: 101 us
			}
			myled = 0;
			
			/* optional: Waveform auf serieller Schnittstelle ausgeben
			for (n = 0; n < len; n++){
				printf("%c", buffer[n]);  
			}
			printf("\n");
			*/
		}
		if (tasteB.read() == 0) {	// Wiedergabe 
			
			nSleep.write(1);
			for (n = 0; n < len; n++) {
				in1.write(float(255-buffer[n]) / 255);
				wait_us(interval-72);   // gemessene Laufzeit der vorigen Zeile: 72 us
			}
			nSleep.write(0);
			
		}
	}     
}